#!/bin/sh

# redirect all output to a log file
#exec > /mnt/system/restartavos.log 2>&1

# if original avos is not running then don't restart
if [ "`pidof avos_helper.sh`x" = "x" ]; then exit 0; fi 

#echo "killing network services..."
killall smbd
killall nmbd
killall downloadd
killall upnpd
killall sshd

rm -f /tmp/smbd.pid
rm -f /tmp/nmbd.pid
rm -fr /tmp/samba*
rm -fr /tmp/download*
rm -f /tmp/upnpd.pid
rm -fr /tmp/upnpd
rm -f /tmp/sshd.pid

#echo "killing udhcpc..."
killall udhcpc
rm -f /tmp/resolv.conf
rm -f /tmp/udhcpc.vars
rm -f /tmp/udhcpc.pid

#echo "killing wpa_supplicant..."
killall wpa_supplicant
rm -f /tmp/wpa_supplicant/eth0
rm -f /tmp/wpa_ctrl*

#echo "bringing eth0 down..."
ifconfig eth0 down

#echo "removing modules..."
rmmod sd8xxx sdio sdio_host_davinci sdio_dma_davinci sdio_core

#echo "killing avos..."
kill `pidof avos_helper.sh`

if [ -d /tmp/opera_home ]; then rm -fr /tmp/opera_home; fi

#echo "inserting modules..."
insmod /lib/modules/sdio-core.ko
insmod /lib/modules/sdio_dma_davinci.ko
insmod /lib/modules/sdio_host_davinci.ko

#echo "restarting avos (2.1.04 unlocked)..."
HACKDIR=/mnt/system/hack
if [ ! -d "$HACKDIR"/usr/bin ]; then
  mkdir -p "$HACKDIR"/usr/bin
  cp -a /usr/bin/* "$HACKDIR"/usr/bin
 
  if [ `/mnt/data/sys_info v` = 2.1.04 ]; then 
  # apply binary edits to avos to unlock plugins ( thanks archilles :) )
  echo -ne '\xe3' | dd of="$HACKDIR"/usr/bin/avos conv=notrunc bs=1 seek=$((0x244c47))
  echo -ne '\0\0\xa0\xe3\x1e\xff\x2f\xe1' | dd of="$HACKDIR"/usr/bin/avos conv=notrunc bs=1 seek=$((0x90f0b8))
  echo -ne '\x01\x30\xa0\xe3' | dd of="$HACKDIR"/usr/bin/avos conv=notrunc bs=1 seek=$((0x91023c))
  echo -ne '\xe3' | dd of="$HACKDIR"/usr/bin/avos conv=notrunc bs=1 seek=$((0x910663))
  echo -ne '\0\0\0\0\0\0' | dd of="$HACKDIR"/usr/bin/avos conv=notrunc bs=1 seek=$((0x9f5978))
 fi
fi

# check for (hacked) avos in /mnt/data and if present use it
if [ -f /mnt/data/avos ]; then 
  cp /mnt/data/avos "$HACKDIR"/usr/bin
  mv /mnt/data/avos /mnt/data/avosx
fi

# bind mount /usr/bin on $HACKDIR/usr/bin
if [ "`mount | sed -n '/usr\/bin/p'`x" = "x" ]; then
  mount -o bind "$HACKDIR"/usr/bin /usr/bin
fi

#restart sshd if appropriate
if [ -d /tmp/ssh ]; then /tmp/ssh/sshd -f /tmp/ssh/sshd_config; fi

# ensure we have a clean environmnet before restarting avos
unset SSH_CLIENT
unset SSH_CONNECTION
unset LOGNAME
unset MAIL
unset LANG
unset LC_ALL
unset OPERA_HOME
unset OPERA_DIR
unset FLASH_TMPDIR
export POS=0
export USER=root
export TERM=linux
export ROOT_PATH=/mnt/system
export PWD=/
export HOME=/
export LD_LIBRARY_PATH=/opt/usr/lib
export PATH=/bin:/sbin:/usr/bin:/usr/sbin:/opt/usr/bin:/opt/usr/sbin:/usr/local/bin

/usr/bin/avos
/sbin/reboot
while true; do sleep 1; done
